package com.example.ordermangement.order_management.controller;

import com.example.ordermangement.order_management.dto.Orderdto;
import com.example.ordermangement.order_management.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/orders")
public class OrderController {


    @Autowired
    private OrderService orderService;

    @GetMapping
    public Flux<Orderdto> getAllTheOrders(){
        return  orderService.getAllOrders();
    }

    @GetMapping("/{id}")
    public Mono<Orderdto> getTheOrderById(@PathVariable String id){
        return  orderService.getOrderById(id);
    }


    @PostMapping("/saveorder")
    public Mono<Orderdto> saveTheOrder(@RequestBody Mono<Orderdto> orderdtoMono){
        return orderService.createOrder(orderdtoMono);
    }

    @PutMapping("/update/{id}")
    public Mono<Orderdto> updateTheOrder(@RequestBody Mono<Orderdto> orderdtoMono,@PathVariable String id){
        return orderService.orderUpadte(orderdtoMono,id);
    }

    @DeleteMapping("/delete/{id}")
    public Mono<Void> deleteTheOrder(String id){
        return orderService.orderDelete(id);
    }
}
