package com.example.ordermangement.order_management.service;

import com.example.ordermangement.order_management.dto.Orderdto;
import com.example.ordermangement.order_management.repository.OrderRepository;
import com.example.ordermangement.order_management.utils.AppUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class OrderService {

    @Autowired
    private OrderRepository orderRepository;

    public Flux<Orderdto> getAllOrders(){
        return orderRepository.findAll()
                .map(AppUtils::entityToDto);
    }

    public Mono<Orderdto> getOrderById(String orderId){
        return  orderRepository.findById(orderId)
                .map(AppUtils::entityToDto);
    }

    public Mono<Orderdto> createOrder(Mono<Orderdto> orderdtoMono){
        return orderdtoMono.map(AppUtils::DtoToentity)
                .flatMap(orderRepository::insert)
                .map(AppUtils::entityToDto);
    }
    public Mono<Orderdto> orderUpadte(Mono<Orderdto> orderdtoMono,String id){
        return  orderRepository.findById(id)
                .flatMap(o->orderdtoMono.map(AppUtils::DtoToentity))
                .doOnNext(e->e.setOrderId(id))
                .flatMap(orderRepository::save)
                .map(AppUtils::entityToDto);
    }

    public Mono<Void> orderDelete(String id){
        return orderRepository.deleteById(id);
    }

 }
